/*
 *      Copyright (C) 2004, 2005, 2006 Alex Marandon
 *
 *  This file is part of slag, a pattern-based audio sequencer.
 *
 *  slag is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  slag is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with slag; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
//
// Interface  libao bas sur un callback
// 
// $Id: LibaoDriver.h,v 1.6 2006/04/09 00:27:58 rhizome Exp $
//

#ifndef LIBAO_DRIVER_H
#define LIBAO_DRIVER_H

#include <qthread.h>

#include "LibaoWrapper.h"
#include "AudioDriver.h"

class LibaoDriver : public AudioDriver, public QThread {
	sample_t * audio_buffer;
        bool active;
	LibaoWrapper ao_wrapper;
	void run();
    public:
	LibaoDriver(ProcessCallback, const int buf_size);
	~LibaoDriver();
	void connect();
	void disconnect();
};

#endif

//EOF
